#ifndef _FingerPrint_H_
#define _FingerPrint_H_


//conveniences
#include <deque>

using namespace std;

/**
   instantiate this in your class and treat it like an array of random
   floats. Anywhere you ask for a random float, one will be generated
   the first time at that index and reused until you dealloc.
   @author jtnimoy
   @code
   // here is a simple example on using your FingerPrint.
   // I usually name my instances `rnd`.
   FingerPrint rnd; // allocate in stack scope.
   cout << rnd[0] << ' ' << rnd[1] << endl ;
   cout << rnd[0] << ' ' << rnd[1] << endl ;
   @endcode
*/
class FingerPrint{
 public:
  deque<float> vals; ///< the repository for the generated random values.
  float operator[](int i); ///< indexer overload for actually getting the random values outa there.
};


#endif

